#ifdef OS_2
#include <stdio.h>
#include <string.h>
#define INCL_NOPM
#define INCL_DOS
#define INCL_VIO
#include <os2.h>
#include "snserver.h"
#include "ffind.h"
#include "modem.h"

extern  void near StackOvl(int err);
#define NEVER       // never say never...
#ifdef NEVER

extern void far pascal InitializeMED(void); /* for MultiScope postmortem debugger */
extern  int pascal far ZeroDiv(void );
extern  int LogOpen(void );
extern  void LogClose(void );
extern  void LogFlush(void );
extern  int cdecl LogWrite(char *fmt);
extern  int cdecl SnWrite(char *fmt);

void medinit2(void)
{
    PFN oldvect;
    extern void ( near * _aexit_rtn)(int errorlevel);

#ifdef MULTISCOPE
    InitializeMED();
#endif
    DosSetVec(VECTOR_DIVIDE_BY_ZERO, ZeroDiv, &oldvect);
    _aexit_rtn = StackOvl;
}

int pascal far ZeroDiv(void)
{
    char *msg = "\r\nDivide by zero\r\n";
    char far *null = 0L;
    VioWrtTTY(msg, strlen(msg), 0);
    *null = 0;                  /* cuase GP fault */
    return(0);
}

void near StackOvl(int err)
{
    int far *null = 0L;
    *null = err;                /* cuase GP fault */
}

#endif // NEVER

void _loadds textify(void);

void pascal far CleanUp(int flag)
{
    HFILE hand;
    char *msg;
    char str[200];
    USHORT bytes;

    setvbuf(stdout, NULL, _IONBF, 0);
    hand = ComGetFH(hcModem);
    if( hand == -1 ) hand = 0;
    if(!ComIsOnline(hcModem)) hand = 0;
    switch(flag){
        case TC_EXIT       :  // Normal exit
            msg = "Normally[0m";
            break;
        case TC_HARDERROR  :  // Hard-error abort
            msg = "due to a hardware error";
            break;
        case TC_KILLPROCESS:  // Unintercepted DosKillProcess
            msg = "because it was killed by another process";
#if 0
            if(check4pmd())
                strcat(msg, " (MED kicked in too)");
#endif
            break;
        case TC_TRAP       :  // Trap operation
            msg = "because of an exception trap (bad bug!)";
            break;
        default:
            msg = "for unknown reasons";
            break;
    }
    sprintf(str, "\n[0m[1mThe bbs has ended %s.\r\n", msg);
    printf(str);
    if(hand)
        DosWrite(hand, str, strlen(str), &bytes);
    if(flag != TC_EXIT){
        sprintf(str, "Please wait while an attempt is made to record this bad news...\r\n[0m");
        printf(str);
        if(hand){
            DosWrite(hand, str, strlen(str), &bytes);
            DosBufReset(hand);
        }
        LogWrite("!!!! Holy bugs Batman.\n");
        textify();
        DosSleep(3000L);
        sprintf(str,"[0mThank you.\r\nBye <sniff>.\r\n");
        printf(str);
        if(hand){
            DosWrite(hand, str, strlen(str), &bytes);
            DosBufReset(hand);
            com_DTR_off();
        }
    }
    LogClose();
    fflush(stdout);
    DosExitList(EXLST_EXIT, 0L);
}

void medinit(void)
{
    medinit2();
    //DosSetVec(VECTOR_DIVIDE_BY_ZERO, 0L, &oldvect);
    DosError(EXCEPTION_DISABLE | HARDERROR_ENABLE); /*PLF Tue  02-27-1990  20:16:31 */
    DosExitList(EXLST_ADD, CleanUp);
}

void medfini(void)
{
    DosExitList(EXLST_REMOVE, CleanUp);
}

#define GRAPHICS_MODE 0x02

void _loadds textify(void)
{
    VIOMODEINFO viomi;
    int row, col, blanklines;
    char buf[200], str[200];

    viomi.cb = sizeof(viomi);
    VioGetMode(&viomi, 0);
    if(viomi.col > sizeof(buf) || (viomi.fbType & GRAPHICS_MODE))
        return;  /* won't work in graphics mode */
    buf[viomi.col] = 0;
    blanklines = 0;
    for(row=0; row < viomi.row; row++){
        VioReadCharStr(buf, &viomi.col, row, 0, 0);
        for(col = viomi.col-1; col>=0; col--){ /* find last blank (eol) */
            if( buf[col] && buf[col] !=' ')
                break;
        }
        if(col == -1){
            blanklines++;           /* blank line */
        }
        else{
            buf[col+1] = 0;
            while(blanklines){
                LogWrite("! CRASH \n");
                SnWrite("! CRASH \n");
                blanklines--;
            }
            sprintf(str, "! CRASH %s\n", buf);
            LogWrite(str);
            SnWrite(str);
        }
    }
}

#endif /* OS_2 */
